---
title: Create an LLM Observability dataset
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Create an LLM Observability dataset{% #create-an-llm-observability-dataset %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                               |
| ----------------- | -------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/llm-obs/v1/{project_id}/datasets      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets |

### Overview

Create a new LLM Observability dataset within the specified project.

### Arguments

#### Path Parameters

| Name                         | Type   | Description                              |
| ---------------------------- | ------ | ---------------------------------------- |
| project_id [*required*] | string | The ID of the LLM Observability project. |

### Request

#### Body Data (required)

Create dataset payload.

{% tab title="Model" %}

| Parent field | Field                        | Type   | Description                                                                    |
| ------------ | ---------------------------- | ------ | ------------------------------------------------------------------------------ |
|              | data [*required*]       | object | Data object for creating an LLM Observability dataset.                         |
| data         | attributes [*required*] | object | Attributes for creating an LLM Observability dataset.                          |
| attributes   | description                  | string | Description of the dataset.                                                    |
| attributes   | metadata                     | object | Arbitrary metadata associated with the dataset.                                |
| attributes   | name [*required*]       | string | Name of the dataset.                                                           |
| data         | type [*required*]       | enum   | Resource type of an LLM Observability dataset. Allowed enum values: `datasets` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "string",
      "metadata": {},
      "name": "My LLM Dataset"
    },
    "type": "datasets"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single LLM Observability dataset.

| Parent field | Field                             | Type      | Description                                                                    |
| ------------ | --------------------------------- | --------- | ------------------------------------------------------------------------------ |
|              | data [*required*]            | object    | Data object for an LLM Observability dataset.                                  |
| data         | attributes [*required*]      | object    | Attributes of an LLM Observability dataset.                                    |
| attributes   | created_at [*required*]      | date-time | Timestamp when the dataset was created.                                        |
| attributes   | current_version [*required*] | int64     | Current version number of the dataset.                                         |
| attributes   | description [*required*]     | string    | Description of the dataset.                                                    |
| attributes   | metadata [*required*]        | object    | Arbitrary metadata associated with the dataset.                                |
| attributes   | name [*required*]            | string    | Name of the dataset.                                                           |
| attributes   | updated_at [*required*]      | date-time | Timestamp when the dataset was last updated.                                   |
| data         | id [*required*]              | string    | Unique identifier of the dataset.                                              |
| data         | type [*required*]            | enum      | Resource type of an LLM Observability dataset. Allowed enum values: `datasets` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T10:30:00Z",
      "current_version": 1,
      "description": "",
      "metadata": {},
      "name": "My LLM Dataset",
      "updated_at": "2024-01-15T10:30:00Z"
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing a single LLM Observability dataset.

| Parent field | Field                             | Type      | Description                                                                    |
| ------------ | --------------------------------- | --------- | ------------------------------------------------------------------------------ |
|              | data [*required*]            | object    | Data object for an LLM Observability dataset.                                  |
| data         | attributes [*required*]      | object    | Attributes of an LLM Observability dataset.                                    |
| attributes   | created_at [*required*]      | date-time | Timestamp when the dataset was created.                                        |
| attributes   | current_version [*required*] | int64     | Current version number of the dataset.                                         |
| attributes   | description [*required*]     | string    | Description of the dataset.                                                    |
| attributes   | metadata [*required*]        | object    | Arbitrary metadata associated with the dataset.                                |
| attributes   | name [*required*]            | string    | Name of the dataset.                                                           |
| attributes   | updated_at [*required*]      | date-time | Timestamp when the dataset was last updated.                                   |
| data         | id [*required*]              | string    | Unique identifier of the dataset.                                              |
| data         | type [*required*]            | enum      | Resource type of an LLM Observability dataset. Allowed enum values: `datasets` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T10:30:00Z",
      "current_version": 1,
      "description": "",
      "metadata": {},
      "name": "My LLM Dataset",
      "updated_at": "2024-01-15T10:30:00Z"
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export project_id="a33671aa-24fd-4dcd-9b33-a8ec7dde7751" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/llm-obs/v1/${project_id}/datasets" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "name": "My LLM Dataset"
    },
    "type": "datasets"
  }
}
EOF 
                
##### 

```python
"""
Create an LLM Observability dataset returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
from datadog_api_client.v2.model.llm_obs_dataset_data_attributes_request import LLMObsDatasetDataAttributesRequest
from datadog_api_client.v2.model.llm_obs_dataset_data_request import LLMObsDatasetDataRequest
from datadog_api_client.v2.model.llm_obs_dataset_request import LLMObsDatasetRequest
from datadog_api_client.v2.model.llm_obs_dataset_type import LLMObsDatasetType

body = LLMObsDatasetRequest(
    data=LLMObsDatasetDataRequest(
        attributes=LLMObsDatasetDataAttributesRequest(
            name="My LLM Dataset",
        ),
        type=LLMObsDatasetType.DATASETS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_llm_obs_dataset"] = True
with ApiClient(configuration) as api_client:
    api_instance = LLMObservabilityApi(api_client)
    response = api_instance.create_llm_obs_dataset(project_id="project_id", body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create an LLM Observability dataset returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_llm_obs_dataset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsDatasetRequest.new({
  data: DatadogAPIClient::V2::LLMObsDatasetDataRequest.new({
    attributes: DatadogAPIClient::V2::LLMObsDatasetDataAttributesRequest.new({
      name: "My LLM Dataset",
    }),
    type: DatadogAPIClient::V2::LLMObsDatasetType::DATASETS,
  }),
})
p api_instance.create_llm_obs_dataset("project_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create an LLM Observability dataset returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsDatasetRequest{
		Data: datadogV2.LLMObsDatasetDataRequest{
			Attributes: datadogV2.LLMObsDatasetDataAttributesRequest{
				Name: "My LLM Dataset",
			},
			Type: datadogV2.LLMOBSDATASETTYPE_DATASETS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateLLMObsDataset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewLLMObservabilityApi(apiClient)
	resp, r, err := api.CreateLLMObsDataset(ctx, "project_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.CreateLLMObsDataset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.CreateLLMObsDataset`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create an LLM Observability dataset returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.LlmObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsDatasetDataAttributesRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetDataRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetResponse;
import com.datadog.api.client.v2.model.LLMObsDatasetType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createLLMObsDataset", true);
    LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);

    LLMObsDatasetRequest body =
        new LLMObsDatasetRequest()
            .data(
                new LLMObsDatasetDataRequest()
                    .attributes(new LLMObsDatasetDataAttributesRequest().name("My LLM Dataset"))
                    .type(LLMObsDatasetType.DATASETS));

    try {
      LLMObsDatasetResponse result =
          apiInstance.createLLMObsDataset("a33671aa-24fd-4dcd-9b33-a8ec7dde7751", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling LlmObservabilityApi#createLLMObsDataset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create an LLM Observability dataset returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsDatasetDataAttributesRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetDataRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetType;

#[tokio::main]
async fn main() {
    let body = LLMObsDatasetRequest::new(LLMObsDatasetDataRequest::new(
        LLMObsDatasetDataAttributesRequest::new("My LLM Dataset".to_string()),
        LLMObsDatasetType::DATASETS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateLLMObsDataset", true);
    let api = LLMObservabilityAPI::with_config(configuration);
    let resp = api
        .create_llm_obs_dataset("project_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create an LLM Observability dataset returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createLLMObsDataset"] = true;
const apiInstance = new v2.LLMObservabilityApi(configuration);

const params: v2.LLMObservabilityApiCreateLLMObsDatasetRequest = {
  body: {
    data: {
      attributes: {
        name: "My LLM Dataset",
      },
      type: "datasets",
    },
  },
  projectId: "project_id",
};

apiInstance
  .createLLMObsDataset(params)
  .then((data: v2.LLMObsDatasetResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
